package progWeb.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.tomcat.util.http.fileupload.IOUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
public class MyController {

	@RequestMapping(value = "/helloWorld", method = RequestMethod.GET)
	public void myFirstEndPoint(HttpServletRequest request, HttpServletResponse response)
			throws UnsupportedEncodingException, IOException {
		System.out.println(request.getProtocol());
		System.out.println("Hello Console");
		response.getOutputStream().write("Hello Client!".getBytes("UTF-8"));
		response.setHeader("entete", "modifiée");
	}

	@RequestMapping(value = "/unePage", method = RequestMethod.GET)
	public void getAPage(HttpServletRequest request, HttpServletResponse response)
			throws UnsupportedEncodingException, IOException {

		String streamContent = "<!DOCTYPE html>	<html>	<head>	<meta charset=\"UTF-8\">	<title>du html</title></head>	<body>	<p>	une page en <br> html	</p>	</body>	</html>";
		response.getOutputStream().write(streamContent.getBytes("UTF-8"));
		
	}

	@RequestMapping(value = "/uneImage", method = RequestMethod.GET)
	public void myImageRequest(HttpServletRequest request, HttpServletResponse response)
			throws UnsupportedEncodingException, IOException {

		// ouverture du fichier java
		File file = new File("/home/alice/enseignement/progWeb/javaLogo.png");
		FileInputStream fis = new FileInputStream(file);

		// signaler que l'on envoie une image
		response.setHeader(HttpHeaders.CONTENT_TYPE, "image/jpg");

		// copier l'image sur le flux de sortie
		IOUtils.copy(fis, response.getOutputStream());

		// fermer le fichier
		IOUtils.closeQuietly(fis);
		// fermer la sortie
		IOUtils.closeQuietly(response.getOutputStream());
	}

	@GetMapping(value = "/retourIndex")
	public void goBack(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.sendRedirect("");
	}

}
